#ifdef _WIN32
#include <windows.h>
#endif

#include "audio.h"

static char *bounceWallFile = "data/audio/parede.wav";
static char *bouncePadFile = "data/audio/pad.wav";
static char *gameSndFile = "data/audio/backloop.wav";
static char *gameGoalFile = "data/audio/goal.wav";
static char *menuMusic = "data/audio/bassmeup.ogg";

Mix_Chunk *bWall = NULL;
int bWallCanal = 2;

Mix_Chunk *bPad = NULL;
int bPadCanal = 2;

Mix_Chunk *gSnd = NULL;
int gSndCanal = 2;

Mix_Chunk *gGoal = NULL;
int gGoalCanal = 2;

Mix_Music *music = NULL;
int gMeMusic = 2;

void initAudio()
{
    //TODO tratar dos outros erros
    int audio_rate = 22050;
    Uint16 audio_format = AUDIO_S16LSB;
    int audio_channels = 2;
    int audio_buffers = 512;
    if (Mix_OpenAudio
	(audio_rate, audio_format, audio_channels, audio_buffers)) {
	printf("Unable to open audio!\n");
	SDL_Quit();
    }
    bWall = Mix_LoadWAV(bounceWallFile);
    if (!bWall) {
	printf("Mix_LoadWAV: %s\n", Mix_GetError());
    }
    bPad = Mix_LoadWAV(bouncePadFile);
    if (!bPad) {
	printf("Mix_LoadWAV: %s\n", Mix_GetError());
    }
    gSnd = Mix_LoadWAV(gameSndFile);

    gGoal = Mix_LoadWAV(gameGoalFile);
    if (!gGoal) {
	printf("Mix_LoadWAV: %s\n", Mix_GetError());
    }
    music = Mix_LoadMUS(menuMusic);
}

void ingameSound()
{
    gSndCanal = Mix_PlayChannel(2, gSnd, -1);
}

void ingameMusic()
{
    gMeMusic = Mix_PlayMusic(music, -1);
}

void bouncePad()
{
    if (inMenu) {
	Mix_Volume(-1, MIX_MAX_VOLUME / 3);
    } else {
	Mix_Volume(-1, MIX_MAX_VOLUME);
    }

    bPadCanal = Mix_PlayChannel(-1, bPad, 0);
}

void bounceWall()
{
    if (inMenu) {
	Mix_Volume(-1, MIX_MAX_VOLUME / 3);
    } else {
	Mix_Volume(-1, MIX_MAX_VOLUME);
    }
    bWallCanal = Mix_PlayChannel(-1, bWall, 0);
}


void goal()
{

    gGoalCanal = Mix_PlayChannel(-1, gGoal, 0);
}
