#ifdef _WIN32
#include <windows.h>
#endif

#include "bola.h"
#include "paredes.h"
#include "pad.h"

#include <GL/gl.h>

static char textureFile[100] = "data/video/cara2.bmp";

struct bola bolaAmarela;
/*
 * SDL_Surface ImagemTexturaBola[1]; 
 */
static SDL_Surface *ImagemTexturaBola[1];


void resetBola()
{
    bolaAmarela.posBola[0] = X;
    bolaAmarela.posBola[1] = (int) Y;
    bolaAmarela.posBola[2] = (int) Z;
    bolaAmarela.velBola[0] = V_X*(pow(-1, (float)rand()));
    bolaAmarela.velBola[1] = V_Y*(pow(-1,(float)rand()));
    bolaAmarela.velBola[2] = V_Z;

}
void resetChoques()
{
  bolaAmarela.nChoques=0;
}

int getChoques()
{
  return(bolaAmarela.nChoques);
}
void CarregaTexturaGL()
{
    int estado = FALSE;

    /*
     * Cria espao para armazenar a textura SDL_Surface
     * *ImagemTexturaBola[1]; 
     */

    /*
     * Tenta carregar a imagem, caso no consiga devolve erro 
     */
    if ((ImagemTexturaBola[0] = SDL_LoadBMP(textureFile))) {
	estado = TRUE;

	/*
	 * Cria a textura 
	 */
	glGenTextures(1, &bolaAmarela.texture[0]);

#ifdef _WIN32
#define GL_BGR GL_BGR_EXT
#endif

	glBindTexture(GL_TEXTURE_2D, bolaAmarela.texture[0]);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, ImagemTexturaBola[0]->w,
		     ImagemTexturaBola[0]->h, 0, GL_BGR,
		     GL_UNSIGNED_BYTE, ImagemTexturaBola[0]->pixels);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    }
    /*
     * if ( ImagemTexturaBola[0] ) SDL_FreeSurface( ImagemTexturaBola[0]); 
     */
    /*
     * return estado; 
     */
}



void initBola()
{
    CarregaTexturaGL();

    bolaAmarela.esfera = gluNewQuadric();

    gluQuadricTexture(bolaAmarela.esfera, GL_TRUE);

    bolaAmarela.posBola[0] = X;
    bolaAmarela.posBola[1] = (int) Y;
    bolaAmarela.posBola[2] = (int) Z;
    bolaAmarela.velBola[0] = V_X*(pow(-1, (float)rand()));
    bolaAmarela.velBola[1] = V_Y*(pow(-1, (float)rand()));
    bolaAmarela.velBola[2] = V_Z;

}

void desenhaBola()
{
    /*
     *As luzes nao devem aqui estar
     GLfloat pos[4] = {0.0, 0.0, 0.0, 1.0};
     GLfloat color[4] = {1.0, 1.0, 1.0, 1.0};

     glLightfv(GL_LIGHT0, GL_AMBIENT, color);
     glLightfv(GL_LIGHT0, GL_POSITION, pos);
     glEnable(GL_LIGHT0);
     glEnable(GL_LIGHTING); 
     */
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();

    /*
     * glEnable(GL_CULL_FACE); 
     */
    glEnable(GL_TEXTURE_2D);

    glColor4f(1.0, 1.0, 1.0, 1.0);
    glBindTexture(GL_TEXTURE_2D, bolaAmarela.texture[0]);
    glTranslatef(bolaAmarela.posBola[0], bolaAmarela.posBola[1],
		 bolaAmarela.posBola[2]);
    gluSphere(bolaAmarela.esfera, RAIO_BOLA, SLICES, STACKS);

    glPopMatrix();
}

void viraBolaDireita()
{
    if (bolaAmarela.velBola[0] < 0) {
	bolaAmarela.velBola[0] = -1 * bolaAmarela.velBola[0];
    }
}
void viraBolaEsquerda()
{
    if (bolaAmarela.velBola[0] > 0)
	bolaAmarela.velBola[0] = -1 * bolaAmarela.velBola[0];
}

void actualizaBola(float deltaT)
{
    GLfloat coordenadas[7];
    GLfloat *ptr = &coordenadas[0];

    int i;
    for (i = 0; i < 3; i++) {
	bolaAmarela.posBola[i] += bolaAmarela.velBola[i] * deltaT;
    }

    /*
     * Vamos enviar as coordenadas virtuais para a parede e receber as
     * reais e o numero de choques com as paredes 
     */
    /*
     * As 3 primeiras leva as coordenadas, depois o raio, depois os
     * choques em x, y e z 
     */
    //DEBUG
    //printf("Gerar vector e ponteiro\n");

    //printf("Inicializar vector\n");
    for (i = 0; i < 3; i++) {
	coordenadas[i] = bolaAmarela.posBola[i];
    }

    coordenadas[3] = RAIO_BOLA;
    coordenadas[4] = 0;
    coordenadas[5] = 0;
    coordenadas[6] = 0;

    /*
     * enviar o array 
     */
    //DEBUG
    //printf("Chamar choque\n");
    choqueParede(ptr);
    //printf("coordenadas: ");
    /* for (i = 0; i < 3; i++) {
	printf(" %f", coordenadas[4 + i]);
    }
    printf("\n");
    */
    /*
     * Estamos prontos a actualizar o versor da velocidade e a posio da
     * bola 
     */
    for (i = 0; i < 3; i++) {
	bolaAmarela.posBola[i] = coordenadas[i];
	bolaAmarela.velBola[i] =
	    (int) (pow(-1, coordenadas[4 + i])) * bolaAmarela.velBola[i];
    }
    //DEBUG
    /*
    printf("posBola: %f %f %f\n", bolaAmarela.posBola[0],
	   bolaAmarela.posBola[1], bolaAmarela.posBola[2]);
    printf("velBola: %f %f %f\n", bolaAmarela.velBola[0],
	   bolaAmarela.velBola[1], bolaAmarela.velBola[2]);
    */
}

GLfloat getVXbola()
{
    return (bolaAmarela.velBola[0]);
}

GLfloat getVYbola()
{
    return (bolaAmarela.velBola[1]);
}

GLfloat getVZbola()
{
    return (bolaAmarela.velBola[2]);
}


GLfloat getXbola()
{
    return (bolaAmarela.posBola[0]);
}

GLfloat getYbola()
{
    return (bolaAmarela.posBola[1]);
}


void inqChoque()
{
  bolaAmarela.nChoques++;
  bolaAmarela.velBola[2]+=0.001;
  bolaAmarela.velBola[1]+=0.0001;
  bolaAmarela.velBola[0]+=0.0002;
}
