#ifdef _WIN32
#include <windows.h>
#endif

#include "pad.h"
#include "paredes.h"
#include "main.h"
#include "menu.h"


#ifdef _WIN32
#include <SDL_syswm.h>
#include <gl\glaux.h>
HDC hDC = NULL;			// Private GDI Device Context
HGLRC hRC = NULL;		// Permanent Rendering Context
HWND hWnd = NULL;		// Holds Our Window Handle
HINSTANCE hInstance;		// Holds The Instance Of The Application

SDL_SysWMinfo WMInfo;
#endif

GLuint base;



GLvoid buildFont(GLvoid)
{ 
    //As display lists tem de ser definidas de diferente forma para X11 e Window$
#ifndef _WIN32
    Display *dpy;		/* Our current X display */
    XFontStruct *fontInfo;	/* Our font info */

    /* Sotrage for 96 characters */
    base = glGenLists(96);

    /* Get our current display long enough to get the fonts */
    dpy = XOpenDisplay(NULL);

    /* Get the font information */
    fontInfo =
	XLoadQueryFont(dpy,
		       "-adobe-helvetica-medium-r-normal--36-*-*-*-p-*-iso8859-1");

    /* If the above font didn't exist try one that should */
    if (fontInfo == NULL) {
	fontInfo = XLoadQueryFont(dpy, "fixed");
	/* If that font doesn't exist, something is wrong */
	if (fontInfo == NULL) {
	    fprintf(stderr, "no X font available?\n");
	    Quit(1);
	}
    }

    /* generate the list */
    glXUseXFont(fontInfo->fid, 32, 96, base);

    /* Recover some memory */
    XFreeFont(dpy, fontInfo);

    /* close the display now that we're done with it */
    XCloseDisplay(dpy);

#endif


#ifdef _WIN32

    HFONT font;			// Windows Font ID
    HFONT oldfont;		// Used For Good House Keeping

	SDL_VERSION(&WMInfo.version);
	SDL_GetWMInfo(&WMInfo);

    base = glGenLists(96);	// Storage For 96 Characters
    printf("Criar a font\n");
    font = CreateFont(24,	// Height Of Font
		      0,	// Width Of Font
		      0,	// Angle Of Escapement
		      0,	// Orientation Angle
		      FW_BOLD,	// Font Weight
		      FALSE,	// Italic
		      FALSE,	// Underline
		      FALSE,	// Strikeout
		      ANSI_CHARSET,	// Character Set Identifier
		      OUT_TT_PRECIS,	// Output Precision
		      CLIP_DEFAULT_PRECIS,	// Clipping Precision
		      ANTIALIASED_QUALITY,	// Output Quality
		      FF_DONTCARE | DEFAULT_PITCH,	// Family And Pitch
		      "Arial");	// Font Name

	hDC = GetDC(WMInfo.window);
    oldfont = (HFONT) SelectObject(hDC, font);	// Selects The Font We Want
    wglUseFontBitmaps(hDC, 32, 96, base);	// Builds 96 Characters Starting At Character 32
    SelectObject(hDC, oldfont);	// Selects The Font We Want
    DeleteObject(font);		// Delete The Font

#endif
    return;
}

/* Print our GL text to the screen */
GLvoid glPrint(const char *fmt, ...)
{
    char text[256];		/* Holds our string */
    va_list ap;			/* Pointer to our list of elements */

    /* If there's no text, do nothing */
    if (fmt == NULL)
	return;

    /* Parses The String For Variables */
    va_start(ap, fmt);
    /* Converts Symbols To Actual Numbers */
    vsprintf(text, fmt, ap);
    va_end(ap);

    /* Pushes the Display List Bits */
    glPushAttrib(GL_LIST_BIT);

    /* Sets base character to 32 */
    glListBase(base - 32);

    /* Draws the text */
    glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);

    /* Pops the Display List Bits */
    glPopAttrib();
}
